## NMSettingIP6Config NMSettingIP6Config — Describes IPv6 addressing, routing, and name service properties |

## Functions

NMSetting * | nm_setting_ip6_config_new ()
NMSettingIP6ConfigPrivacy | nm_setting_ip6_config_get_ip6_privacy ()
NMSettingIP6ConfigAddrGenMode | nm_setting_ip6_config_get_addr_gen_mode ()
const char * | nm_setting_ip6_config_get_token ()
const char * | nm_setting_ip6_config_get_dhcp_duid ()
gint32 | nm_setting_ip6_config_get_ra_timeout ()
guint32 | nm_setting_ip6_config_get_mtu ()
const char * | nm_setting_ip6_config_get_dhcp_pd_hint ()

## Types and Values

#define | NM_SETTING_IP6_CONFIG_SETTING_NAME
#define | NM_SETTING_IP6_CONFIG_IP6_PRIVACY
#define | NM_SETTING_IP6_CONFIG_ADDR_GEN_MODE
#define | NM_SETTING_IP6_CONFIG_TOKEN
#define | NM_SETTING_IP6_CONFIG_DHCP_DUID
#define | NM_SETTING_IP6_CONFIG_RA_TIMEOUT
#define | NM_SETTING_IP6_CONFIG_MTU
#define | NM_SETTING_IP6_CONFIG_DHCP_PD_HINT
#define | NM_SETTING_IP6_CONFIG_METHOD_IGNORE
#define | NM_SETTING_IP6_CONFIG_METHOD_AUTO
#define | NM_SETTING_IP6_CONFIG_METHOD_DHCP
#define | NM_SETTING_IP6_CONFIG_METHOD_LINK_LOCAL
#define | NM_SETTING_IP6_CONFIG_METHOD_MANUAL
#define | NM_SETTING_IP6_CONFIG_METHOD_SHARED
#define | NM_SETTING_IP6_CONFIG_METHOD_DISABLED
enum | NMSettingIP6ConfigPrivacy
enum | NMSettingIP6ConfigAddrGenMode

## Object Hierarchy

        GEnum
        ├── NMSettingIP6ConfigAddrGenMode
        ╰── NMSettingIP6ConfigPrivacy

## Description

The NMSettingIP6Config object is a NMSetting subclass that describes properties related to IPv6 addressing, routing, and Domain Name Service

NMSettingIP6Config has few properties or methods of its own; it inherits almost everything from NMSettingIPConfig.

NetworkManager supports 7 values for the “method” property for IPv6. If "auto" is specified then the appropriate automatic method (PPP, router advertisement, etc) is used for the device and most other properties can be left unset. To force the use of DHCP only, specify "dhcp"; this method is only valid for Ethernet- based hardware. If "link-local" is specified, then an IPv6 link-local address will be assigned to the interface. If "manual" is specified, static IP addressing is used and at least one IP address must be given in the "addresses" property. If "ignore" is specified, IPv6 configuration is not done. Note: the "shared" method is not yet supported. If "disabled" is specified, IPv6 is disabled completely for the interface.

## Functions

### nm_setting_ip6_config_new ()

    NMSetting *
    nm_setting_ip6_config_new (void);

Creates a new NMSettingIP6Config object with default values.

#### Returns

the new empty NMSettingIP6Config object.

[transfer full]

### nm_setting_ip6_config_get_ip6_privacy ()

    NMSettingIP6ConfigPrivacy
    nm_setting_ip6_config_get_ip6_privacy (NMSettingIP6Config *setting);

Returns the value contained in the “ip6-privacy” property.

#### Parameters

setting | the NMSettingIP6Config |

#### Returns

IPv6 Privacy Extensions configuration value (NMSettingIP6ConfigPrivacy).

### nm_setting_ip6_config_get_addr_gen_mode ()

    NMSettingIP6ConfigAddrGenMode
    nm_setting_ip6_config_get_addr_gen_mode
                                   (NMSettingIP6Config *setting);

Returns the value contained in the “addr-gen-mode” property.

#### Parameters

setting | the NMSettingIP6Config |

#### Returns

IPv6 Address Generation Mode.

Since: 1.2

### nm_setting_ip6_config_get_token ()

    const char *
    nm_setting_ip6_config_get_token (NMSettingIP6Config *setting);

Returns the value contained in the “token” property.

#### Parameters

setting | the NMSettingIP6Config |

#### Returns

A string.

Since: 1.4

### nm_setting_ip6_config_get_dhcp_duid ()

    const char *
    nm_setting_ip6_config_get_dhcp_duid (NMSettingIP6Config *setting);

Returns the value contained in the “dhcp-duid” property.

#### Parameters

setting | the NMSettingIP6Config |

#### Returns

The configured DUID value to be included in the DHCPv6 requests sent to the DHCPv6 servers.

Since: 1.12

### nm_setting_ip6_config_get_ra_timeout ()

    gint32
    nm_setting_ip6_config_get_ra_timeout (NMSettingIP6Config *setting);

#### Parameters

setting | the NMSettingIP6Config |

#### Returns

The configured `NM_SETTING_IP6_CONFIG_RA_TIMEOUT` value with the timeout for router advertisements in seconds.

Since: 1.24

### nm_setting_ip6_config_get_mtu ()

    guint32
    nm_setting_ip6_config_get_mtu (NMSettingIP6Config *setting);

#### Parameters

setting | the NMSettingIP6Config |

#### Returns

The configured `NM_SETTING_IP6_CONFIG_MTU` value for the maximum transmission unit.

Since: 1.40

### nm_setting_ip6_config_get_dhcp_pd_hint ()

    const char *
    nm_setting_ip6_config_get_dhcp_pd_hint
                                   (NMSettingIP6Config *setting);

Returns the value contained in the “dhcp-pd-hint” property.

#### Parameters

setting | the NMSettingIP6Config |

#### Returns

a string containing an address and prefix length to be used as hint for DHCPv6 prefix delegation.

Since: 1.44

## Types and Values

### NM_SETTING_IP6_CONFIG_SETTING_NAME

    #define NM_SETTING_IP6_CONFIG_SETTING_NAME "ipv6"

### NM_SETTING_IP6_CONFIG_IP6_PRIVACY

    #define NM_SETTING_IP6_CONFIG_IP6_PRIVACY "ip6-privacy"

### NM_SETTING_IP6_CONFIG_ADDR_GEN_MODE

    #define NM_SETTING_IP6_CONFIG_ADDR_GEN_MODE "addr-gen-mode"

### NM_SETTING_IP6_CONFIG_TOKEN

    #define NM_SETTING_IP6_CONFIG_TOKEN "token"

### NM_SETTING_IP6_CONFIG_DHCP_DUID

    #define NM_SETTING_IP6_CONFIG_DHCP_DUID "dhcp-duid"

### NM_SETTING_IP6_CONFIG_RA_TIMEOUT

    #define NM_SETTING_IP6_CONFIG_RA_TIMEOUT "ra-timeout"

### NM_SETTING_IP6_CONFIG_MTU

    #define NM_SETTING_IP6_CONFIG_MTU "mtu"

### NM_SETTING_IP6_CONFIG_DHCP_PD_HINT

    #define NM_SETTING_IP6_CONFIG_DHCP_PD_HINT "dhcp-pd-hint"

### NM_SETTING_IP6_CONFIG_METHOD_IGNORE

    #define NM_SETTING_IP6_CONFIG_METHOD_IGNORE "ignore"

IPv6 is not required or is handled by some other mechanism, and NetworkManager should not configure IPv6 for this connection.

### NM_SETTING_IP6_CONFIG_METHOD_AUTO

    #define NM_SETTING_IP6_CONFIG_METHOD_AUTO "auto"

IPv6 configuration should be automatically determined via a method appropriate for the hardware interface, ie router advertisements, DHCP, or PPP or some other device-specific manner.

### NM_SETTING_IP6_CONFIG_METHOD_DHCP

    #define NM_SETTING_IP6_CONFIG_METHOD_DHCP "dhcp"

IPv6 configuration should be automatically determined via DHCPv6 only and router advertisements should be ignored.

### NM_SETTING_IP6_CONFIG_METHOD_LINK_LOCAL

    #define NM_SETTING_IP6_CONFIG_METHOD_LINK_LOCAL "link-local"

IPv6 configuration should be automatically configured for link-local-only operation.

### NM_SETTING_IP6_CONFIG_METHOD_MANUAL

    #define NM_SETTING_IP6_CONFIG_METHOD_MANUAL "manual"

All necessary IPv6 configuration (addresses, prefix, DNS, etc) is specified in the setting's properties.

### NM_SETTING_IP6_CONFIG_METHOD_SHARED

    #define NM_SETTING_IP6_CONFIG_METHOD_SHARED "shared"

This connection specifies configuration that allows other computers to connect through it to the default network (usually the Internet). The connection's interface will be assigned a private address, and router advertisements, a caching DNS server, and Network Address Translation (NAT) functionality will be started on this connection's interface to allow other devices to connect through that interface to the default network. (not yet supported for IPv6)

### NM_SETTING_IP6_CONFIG_METHOD_DISABLED

    #define NM_SETTING_IP6_CONFIG_METHOD_DISABLED "disabled"

IPv6 is disabled for the connection.

Since: 1.20

### enum NMSettingIP6ConfigPrivacy

NMSettingIP6ConfigPrivacy values indicate if and how IPv6 Privacy Extensions are used (RFC4941).

#### Members

NM_SETTING_IP6_CONFIG_PRIVACY_UNKNOWN | unknown or no value specified |
NM_SETTING_IP6_CONFIG_PRIVACY_DISABLED | IPv6 Privacy Extensions are disabled |
NM_SETTING_IP6_CONFIG_PRIVACY_PREFER_PUBLIC_ADDR | IPv6 Privacy Extensions are enabled, but public addresses are preferred over temporary addresses |
NM_SETTING_IP6_CONFIG_PRIVACY_PREFER_TEMP_ADDR | IPv6 Privacy Extensions are enabled and temporary addresses are preferred over public addresses |

### enum NMSettingIP6ConfigAddrGenMode

NMSettingIP6ConfigAddrGenMode controls how the Interface Identifier for RFC4862 Stateless Address Autoconfiguration is created.

#### Members

NM_SETTING_IP6_CONFIG_ADDR_GEN_MODE_EUI64 | The Interface Identifier is derived from the interface hardware address. |
NM_SETTING_IP6_CONFIG_ADDR_GEN_MODE_STABLE_PRIVACY | The Interface Identifier is created by using a cryptographically secure hash of a secret host-specific key along with the connection identification and the network address as specified by RFC7217. |
NM_SETTING_IP6_CONFIG_ADDR_GEN_MODE_DEFAULT_OR_EUI64 | Fallback to the global default, and if unspecified use "eui64". Since: 1.40. |
NM_SETTING_IP6_CONFIG_ADDR_GEN_MODE_DEFAULT | Fallback to the global default, and if unspecified use "stable-privacy". Since: 1.40. |

Since: 1.2